var Display = {
	player_bars_hide : true,
	totalTime : 0,

	statusDiv : null,
	status_timer : null
};


Display.init = function() {
	var success = true;
	this.statusDiv = document.getElementById("status");
	if (!this.statusDiv) {
		success = false;
	}
	return success;
};

Display.setTotalTime = function(total) {
	this.totalTime = total;
};

Display.setTime = function(time) {
	var timePercent = (100 * time) / this.totalTime,
			timeElement = document.getElementById("timeInfo"),
			timeHTML = "",
			timeHour = 0,
			timeMinute = 0,
			timeSecond = 0,
			totalTimeHour = 0,
			totalTimeMinute = 0,
			totalTimeSecond = 0;

	document.getElementById("progressBar").style.width = timePercent + "%";

	if (Player.state == Player.PLAYING) {

		totalTimeHour = Math.floor(this.totalTime / 3600000);
		timeHour = Math.floor(time / 3600000);
		totalTimeMinute = Math.floor((this.totalTime % 3600000) / 60000);
		timeMinute = Math.floor((time % 3600000) / 60000);
		totalTimeSecond = Math.floor((this.totalTime % 60000) / 1000);
		timeSecond = Math.floor((time % 60000) / 1000);
		timeHTML = timeHour + ":";

		if (timeMinute == 0) {
			timeHTML += "00:";
		} else if (timeMinute < 10) {
			timeHTML += "0" + timeMinute + ":";
		} else {
			timeHTML += timeMinute + ":";
		}

		if (timeSecond == 0) {
			timeHTML += "00 / ";
		} else if (timeSecond < 10) {
			timeHTML += "0" + timeSecond + " / ";
		} else {
			timeHTML += timeSecond + " / ";
		}
		timeHTML += totalTimeHour + ":";

		if (totalTimeMinute == 0) {
			timeHTML += "00:";
		} else if (totalTimeMinute < 10)
			timeHTML += "0" + totalTimeMinute + ":";
		else {
			timeHTML += totalTimeMinute + ":";

		}

		if (totalTimeSecond == 0) {
			timeHTML += "00";
		} else if (totalTimeSecond < 10) {
			timeHTML += "0" + totalTimeSecond;
		} else
			timeHTML += totalTimeSecond;

		if (totalTimeMinute != 0) {
			if (timeSecond >= totalTimeSecond && timeMinute >= totalTimeMinute
					&& timeHour >= totalTimeHour) {
				Player.stopVideo();
				timeHTML = "0:00:00 / 0:00:00";
				setTimeout("Display.Timeout()", 3000);
			}
		}

	} else {
		timeHTML = "0:00:00 / 0:00:00";
	}
	widgetAPI.putInnerHTML(timeElement, timeHTML);
};

Display.status = function(status) {
	$("#status").css('display','block').html('Статус: ' + status);
	clearTimeout(this.status_timer);
	this.status_timer = setTimeout("Display.hideStatusDiv()",3000);
};

Display.hideplayer = function() {
	clearTimeout(this.infobar_timer);
	$("#player").removeClass('active');
	if (this.state == this.STOPPED) {
		$("#player").removeClass('loading');
	}
	};

Display.showplayer = function() {
	clearTimeout(this.infobar_timer);
	$("#player").addClass('active');
	//alert(content_type);
	if(!player_bars && content_type != "audio" && this.player_bars_hide){
		this.infobar_timer = setTimeout("Display.hideplayer()",3000);
	}
};

Display.togglePlayer = function() {
	if(content_type == "audio"){
		player_bars = true;
		Display.status();
	} else {
		clearTimeout(this.infobar_timer);
		$("#player").toggleClass('active');
	}
};

Display.Timeout = function() {
	Main.selectNextVideo(); // переключение на след. трек
	if (url){
		Main.handlePlayKey(); // играть
	}else{
		Player.stopVideo();
		Main.setWindowMode();
	}
};

/*
Display.setVolume = function(level) {
	document.getElementById("volumeBar").style.width = level + "%";
	var volumeElement = document.getElementById("volumeInfo");
	widgetAPI.putInnerHTML(volumeElement, "     " + Audio.getVolume());
};
*/

/////////////////////// STATUS LINE///////////////////////////////////

Display.statusLine = function(param_string) {
	$("#statusline").css('display','block').html(param_string);
	clearTimeout(this.status_timer);
	this.status_timer = setTimeout("Display.hideStatusDiv()",3000);
};
/////////////////////// STATUS LINE ///////////////////////////////////

Display.hideStatusDiv = function() {
	$(".fs_statusdiv").css('display','none');
};

