var fav_items = {};
var Favorites = {
	isVisible: false,
	fav_qty: 0
};

Favorites.open = function() {
	this.isVisible = true;
	Main.search = false;
	Main.index = 0;
	Main.level = 0;
	$('body').attr('id','level'+Main.level).addClass('favorite');
	$('#searchPath').empty();
	$('#secondary').empty();
	$('#poster').empty().css('display','block');
	$('#sort').empty();
	Main.helpbar();
	Favorites.readAll();
	this.fav_qty = Object.keys(fav_items).length;
	widgetAPI.putInnerHTML(document.getElementById("path"), '<span class="b-section-title__item  m-section-title__item_position_first m-section-title__item_position_pre-last">FS.TO</span><div class="b-section-title__item m-section-title__item_position_last"><h1>Избранное</h1></div>');
	Favorites.showItems();
};

Favorites.addLine = function() {
	var key = Main.current_object_url,
			data = Main.current_object;
	if(Main.search){
		data = data.replace('/5/','/6/');
	} else {
		data = data.replace(/\s+/g, ' ');
	}
	//alert(data);
	//alert(key);
	fav_items[key] = data;
};

Favorites.writeAll = function() {
	var fileSystemObj = new FileSystem();
	if (!fileSystemObj.isValidCommonPath(curWidget.id)) fileSystemObj.createCommonDir(curWidget.id);
	var fileObj = fileSystemObj.openCommonFile(curWidget.id+'/fs_to_fav.data','w');
	if (fileObj) {
		var str = JSON.stringify(fav_items);
		fileObj.writeAll(str);
		fileSystemObj.closeCommonFile(fileObj);
	}
};

Favorites.readAll = function() {
	var fileSystemObj = new FileSystem();
	var fileObj = fileSystemObj.openCommonFile(curWidget.id+'/fs_to_fav.data','r');
	if (fileObj) {
		var strResult = fileObj.readAll();
		if (strResult)
			fav_items = JSON.parse(strResult);
		if(!fav_items)
			fav_items = {};
		fileSystemObj.closeCommonFile(fileObj);
	}
};

Favorites.showItems = function() {
	if (this.fav_qty > 0){
		var main = $('#main').empty();
		$.each(fav_items, function(url, data){
			main.append(data);
		});
		main.scrollTop(0);
		var focus = $('a.subject-link:eq('+Main.index+')', main);
		if(!focus.length){
			Main.index -= 1;
			focus = $('a.subject-link:eq('+Main.index+')', main)
		}
		focus.addClass('subject_focus').siblings().removeClass('subject_focus');
		Main.fav_pager();
		//Main.current_object = focus[0].outerHTML;
		Main.current_object_url = prefixURL + focus.attr('href');
		content_type = focus.attr('href').split('/')[1];
		if(content_type == 'audio'){
			$('body').addClass('audio').removeClass('video');
		} else {
			$('body').addClass('video').removeClass('audio');
		}
	}
};

Favorites.add  = function(){
	Favorites.readAll();
	Favorites.addLine();
	Favorites.writeAll();
	Display.statusLine("Добавленно в избранное");
};

Favorites.del = function(){
	Favorites.readAll();
	Favorites.delLine();
	Favorites.writeAll();
	$('#main').empty();
	Favorites.showItems();
	Main.fav_pager();
	Display.statusLine("Удалено из избранного");
};

Favorites.delLine = function(){
	delete fav_items[Main.current_object_url];
};

Favorites.reset = function() {
	//var fileSystemObj = new FileSystem();
	//var bResult = fileSystemObj.deleteCommonFile(curWidget.id + '/fs_to_fav.data');
};
