var login = '',
	passwd = '',
	uid = '';

var widgetAPI = new Common.API.Widget(),
		tvKey = new Common.API.TVKeyValue(),
		pluginAPI = new Common.API.Plugin(),
		ScreenWidth = 960,
		ScreenHeight = 540,
		supportedExt = ["avi", "asf", "asx", "3gp","3g2", "3gp2", "3gpp", "flv", "mp4", "mp4v", "m4v", "m2v","m2ts", "m2t", "mp2v", "mov", "mpg", "mpe", "mpeg", "mkv","swf", "mts", "wm", "wmx", "wmv", "vob", "iso", "f4v", "ts", "flac", "mp3", "dts", "ac3", "divx"],
		prefixURL = "http://brb.to",
		content_type = 'video',
		content_subtype = 'films',
		sort_by = 'new',
		load_url = prefixURL + '/' + content_type + '/' + content_subtype + '/?sort=' + sort_by,
		breadcrumbs = '',
		time_out = null,
		url = '',
		title = '',
		currentFSMode = 2,
		maxFSMode = 3,
		player_bars = false,
		FS_ADMIXER_PARAMS = {};

showHandler = function() {
	// Стандартный индикатор громкости
	NNaviPlugin = document.getElementById("pluginObjectNNavi");
	//alert("[APPS] : setBannerstate : 1");
	NNaviPlugin.SetBannerState(PL_NNAVI_STATE_BANNER_VOL);
	PL_NNAVI_STATE_BANNER_NONE = 0;
	PL_NNAVI_STATE_BANNER_VOL = 1;
	PL_NNAVI_STATE_BANNER_VOL_CH = 2;
	pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	pluginAPI.unregistKey(tvKey.KEY_MUTE);
	pluginAPI.setOnScreenSaver(300);
};

var Main = {
	version_widget : "0.2.0",

	mode : 0, // состояние полноэкранного режима
	WINDOW : 0,
	FULLSCREEN : 1,

	query_page : 1,

	index : 0, // номер активного канала
	sort_index : 0,
	play_status : 0, // пауза или играть с начала

	level : 0,
	current_object : '',
	current_object_url : '',
	current_object_mark : '',
	current_object_id : '',
	search : false, // search : false, search : true,

	TVPlugin : 0,
	hardware : 0,
	hardware_type : 0,

	mute: 0,
	NMUTE: 0,
	YMUTE: 1

};

Main.onLoad = function() {
	window.onShow =  showHandler; // Стандартный индикатор Volume-OSD

	this.TVPlugin = document.getElementById("pluginTV");
	this.hardware_type = this.TVPlugin.GetProductType();
	this.hardware = this.TVPlugin.GetProductCode(1);
	this.hardware_char=this.hardware.substring(4,5);

	if (Display.init() && Player.init() && Audio.init()) {
		document.getElementById("anchor").focus(); // Помещение фокуса на элемент "anchor"
		widgetAPI.sendReadyEvent(); // Сообщаем менеджеру приложений о готовности

		//Display.setVolume(Audio.getVolume());
		Display.setTime(0);

		$("#widget_ver").text("Model:"+this.hardware+"   Type:"+this.hardware_char+"   v."+Main.version_widget);

		$(function(){
			$(document).ajaxStart(function () {
				$('body').addClass('loading');
			}).ajaxStop(function () {
						$('body').removeClass('loading');
					});
			Favorites.readAll();
			Main.loadLevel0();

		});
	}
};

Main.onUnload = function() {
	Player.deinit();
};

Main.loadLevel0 = function() {
	Favorites.isVisible = false;
	this.search = false;
	this.index = 0;
	$('body').removeClass('favorite');
	$('#poster').empty().css('display','block');
	$("#searchPath").empty();
	this.helpbar();
	var main = $('#main');
	$.ajax({
		type    : "GET",
		url     : load_url,
		cache   : false,
		timeout : 10000,
		success : function (msg) {
			msg = msg.replace(/\s+/g, ' ');
			var login = $('.b-header__user-profile-title', msg).text();
			$('#login').text(login);
			var content = $('div.b-section-list a.subject-link', msg);
			$('b.subject-link', content).remove();
			main.html(content);

			var focus = main.find('a.subject-link:eq(0)');
			if(focus.length){
				var make_object_for_save = focus.clone();
				$('.b-poster-info', make_object_for_save).remove();
				Main.current_object = make_object_for_save.wrap('<div></div>').parent().html();
				Main.current_object_url = prefixURL + make_object_for_save.attr('href');
				focus.addClass('subject_focus');
			}

			var filter = $('.b-filter', msg);
			Main.sort_index = filter.find('.selected').parent().index();
			sort_by = filter.find('.selected').attr('href').split('sort=', 2)[1];
			$('#sort').html('Сортировка:' + filter.html());

			breadcrumbs = $('div.b-section-title__item', msg).parent();
			$('.b-section-title__left-semicircle-first-item', breadcrumbs).remove();
			content_type = $('a:first', breadcrumbs).attr('href').split('/')[1];
			$('#path').html(breadcrumbs.html());
			if(content_type == 'audio'){
				$('body').addClass('audio').removeClass('video');
			} else {
				$('body').addClass('video').removeClass('audio');
			}

			//var pager = $('.b-pager ul', msg);
			Main.pager();
		},
		error   : function (msg) {
			msg = msg.replace(/\s+/g, ' ');
			main.html(msg);
		},
		complete: function (xhr) {
			$('body').removeClass('loading');
			//alert('document:' + JSON.stringify(document.cookie('fs_uid')));
		}
	});

};
Main.loadSearch = function() {
	Favorites.isVisible = false;
	this.search = true;
	this.index = 0;
	$('body').removeClass('favorite');
	$('#poster').empty().css('display','block');
	$('#sort').empty();
	this.helpbar();
	var main = $('#main');
	$.ajax({
		type    : "GET",
		url     : load_url,
		cache   : false,
		timeout : 10000,
		success : function (msg) {
			msg = msg.replace(/\s+/g, ' ');
			var content = $('div.main', msg);
			$('table table, .rate, .feedback', content).remove();
			main.html(content);

			var focus = main.find('tr:eq(0)');
			focus.addClass('subject_focus');

			var make_object_for_save = $('.image-wrap a', focus).clone().addClass('subject-link');
			make_object_for_save.append('<span>'+$('.image-wrap a', focus).attr('title')+'</span>');
			Main.current_object = make_object_for_save[0].outerHTML;
			Main.current_object_url = prefixURL + make_object_for_save.attr('href');
			content_type = make_object_for_save.attr('href').split('/')[1];
			if(content_type == 'audio'){
				$('body').addClass('audio').removeClass('video');
			} else {
				$('body').addClass('video').removeClass('audio');
			}

			//var pager = $('.b-pager ul', msg);
			Main.pager();
		},
		error   : function (msg) {
			main.html(msg);
		},
		complete: function () {
			$('body').removeClass('loading');
		}
	});
};

Main.keyDown = function() {
	var keyCode = event.keyCode;
	this.doKeyEvent(keyCode)
};

Main.doKeyEvent = function(keyCode) {
	var focus, subject_next;
	switch (keyCode) {
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event); //отменяем заводскую реакцию на событие.

			if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN){
				Player.stopVideo();
				Main.setWindowMode();
			}else{
				widgetAPI.sendReturnEvent();// <- выполняем выход из виджета ВОЗВРАТОМ в смартхаб - вместо закрытия смартхаба по widgetAPI.sendExitEvent();
			}
			break;
		case tvKey.KEY_INFO:
			if (this.mode == this.FULLSCREEN){
				player_bars = !player_bars;
				Display.togglePlayer();
			} else {
				$('#info').toggle();
			}
			break;
		case tvKey.KEY_CH_UP:
		case tvKey.KEY_PANEL_CH_UP:
			if (this.level==0 && !Favorites.isVisible){
				var el = $('#pager .next-link');
				if(el.length){
					load_url = el.attr('href');
					Main.query_page = parseInt(el.attr('data-page'));
					if(this.search){
						this.loadSearch();
					} else {
						this.loadLevel0();
					}
				}
			} else if(this.mode == this.WINDOW) {
				var object_description = $('#object_description').is(':visible')? $('#object_description') : $('#object_list');
				var viewheight = $('#secondary').height();
				if(object_description.length){
					object_description.animate({scrollTop: (object_description.scrollTop() - viewheight/2)}, 400);
				}
			}
			break;
		case tvKey.KEY_CH_DOWN:
		case tvKey.KEY_PANEL_CH_DOWN:
			if (this.level==0 && !Favorites.isVisible){
				var el = $('#pager .previous-link');
				if(el.length){
					load_url = el.attr('href');
					Main.query_page = parseInt(el.attr('data-page'));
					if(this.search){
						this.loadSearch();
					} else {
						this.loadLevel0();
					}
				}
			} else if(this.mode == this.WINDOW) {
				var object_description = $('#object_description').is(':visible')? $('#object_description') : $('#object_list');
				var viewheight = $('#secondary').height();
				if(object_description.length){
					object_description.animate({scrollTop: (object_description.scrollTop() + viewheight/2)}, 400);
				}
			}
			break;

		case tvKey.KEY_STOP:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.stopVideo();
				Main.setWindowMode();
			}
			break;
		case tvKey.KEY_PAUSE:
			if (Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED)
				this.handlePauseKey();
			break;
		case tvKey.KEY_PLAY:
			if (Player.getState() != Player.PLAYING && this.mode == this.FULLSCREEN){
				Main.handlePlayKey();
				this.play_status = 1; // играть c начала
			}
			break;
		case tvKey.KEY_FF:
			if(Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
				Player.skipForwardVideo();
			}
			break;
		case tvKey.KEY_RW:
			if(Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
				Player.skipBackwardVideo();
			}
			break;

		case tvKey.KEY_TOOLS: // поиск
			if (this.mode == this.WINDOW){
				Search.Input();
			}
			break;

		case tvKey.KEY_REC:
			if(this.level == 0){
				if($('#login').text()){
					var form = '<form id="auth" method="post" action="'+ prefixURL+'/logout.aspx"><input type="hidden" name="logout" value="1"></form>';
				} else {
					var form = '<form id="auth" method="post" action="' + prefixURL + '/login.aspx"><input type="checkbox" name="remember" checked><input type="text" name="login" value="'+login+'"><input type="password" name="passwd" value="'+passwd+'"></form>';
				}
				$('.auth').html(form);
				$('#auth').submit();

				/*
				Favorites.isVisible = false;
				this.search = true;
				this.index = 0;
				$('body').removeClass('favorite');
				$('#poster').empty().css('display', 'block');
				$('#sort').empty();
				this.helpbar();
				var main = $('#main');
				$.ajax({
					type: "POST",
					url: prefixURL + '/login.aspx?login='+login+'&passwd='+passwd,
					data: { login: login, passwd: passwd, remember: 1 },
					//password: passwd,
					//username: login,
					//async: false,
					//crossDomain: true,
					//processData: false,
					timeout: 10000,
					//beforeSend: function(request){
					//	request.setRequestHeader("User-Agent", "Mozilla/5.0 (Windows NT 5.1) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.83 Safari/537.1 MyAgentCode)");
					//	request.withCredentials = true;
					//},
					//xhrFields: {
					//	withCredentials: true
					//},
					success: function(msg, st, xhr){
						alert(JSON.stringify(xhr.getAllResponseHeaders()));
						main.html(msg);

					},
					error: function(msg){
					},
					complete: function(xhr){
						$('body').removeClass('loading');
						alert(JSON.stringify(xhr.getAllResponseHeaders()));
					}
				});
				*/
			} else if(this.level == 1){
				if($('#login').text()){
					var user_id = Main.getCookies('fs_uid');
					alert('user: '+user_id);
					$.ajax({
						type: "GET",
						url: prefixURL + '/jsfilemanager.aspx?f=files_list&item_id='+ Main.current_object_id+'&id=false&u='+uid,
						cache: false,
						dataType: 'json',
						timeout: 10000,
						success: function(msg){
							var level_0 = Main.getList(msg, '0');

							var content = '<div class="header"><b>FTP List</b></div><ul class="ftplist">';
							content += Main.htmlList(level_0, msg);
							content += '</ul>';
							$('#FTP').html(content);
						},
						error: function(msg){
						},
						complete: function(){
							$('body').removeClass('loading');
						}
					});
				}
			}

			break;
		case tvKey.KEY_ENTER:
		case tvKey.KEY_PANEL_ENTER:
			if (this.level == 0) {
				this.level = 1;
				if(this.search){
					this.current_object_url = prefixURL + $('.subject_focus .image-wrap a').attr('href');
				} else {
					this.current_object_url = prefixURL + $('.subject_focus').attr('href');
				}
				Main.helpbar();
				$.ajax({
					type    : "GET",
					url     : Main.current_object_url+'?ajax&folder=0',
					cache   : false,
					timeout : 10000,
					success : function (msg) {
						msg = msg.replace(/\s+/g, ' ');
						var content = $(msg);
						$('.b-transparent-area, a.link-more, .b-subtypes-list',content).remove();
						$('#secondary').append('<div id="object_description"></div><div id="object_list"><ul class="filelist">'+content.html()+'<li class="folder" id="FTP"></li></ul></div>');
						$('#object_list li:eq(0)').addClass('subject_focus');
					},
					error   : function (msg) {
						msg = msg.replace(/\s+/g, ' ');
						$('#secondary').append('<div id="object_list">'+msg+'</div>');
					},
					complete: function () {
						$('body').removeClass('loading');
						$.ajax({
							type    : "GET",
							url     : Main.current_object_url,
							async		: false,
							cache   : false,
							dataType: 'text',
							timeout : 10000,
							success : function (msg) {
								msg = msg.split('l-tab-item-content')[1];
								msg = msg.split('<!--')[0];
								msg = msg.replace(/<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi, '');
								msg = msg.replace(/\s+/g, ' ');
								msg = msg.replace(/href=\s?"[^"]*"/gi, 'href="#"');
								//msg = msg.replace(/rel=\s?"[^"]*"/gi, '');
								var flag_url = 'http://fsua.dotua.org/img/interface/flags/' + msg.split('/flags/',2)[1].split('\');',2)[0];
								msg = msg.replace(/style=\s?"[^"]*"/gi, '');
								msg = msg.replace(' indx="0"', '');
								msg = '<div class="l-tab-item-content' + msg;

								var content = $(msg);
								$('.b-tab-item__trailer, .b-tab-item__screens, .b-tab-item__vote, .b-tab-item__add-to, .b-tab-item__edit-material, .b-adsuniversal-wrap, .b-scroll-to, .b-read-all, script, #b-online-watch-source', content).remove();
								var item_info = eval("(function(){return " + $('.b-files-folders-link', content).attr('rel') + ";})()");
								Main.current_object_id = item_info.item_id;

								$('.b-actions-panel', content).remove();
								var poster_img = '<img src="'+ $('.poster-main img', content).attr('src') + '" />';

								$('.poster-main', content).html(poster_img);
								$('.tag-country-flag', content).css('background-image','url('+flag_url+')');
								$('.link-show-more-attribute', content).siblings().css('display', 'inline-block').end().remove();

								$('#object_description').html(content).hide();
								$('#poster').show().html(poster_img);
							},
							error   : function (msg) {
								msg = msg.replace(/\s+/g, ' ');
								$('#object_description').html(msg);
							},
							complete: function () {
								$('body').removeClass('loading');
							}
						});
					}
				});
			} else if(this.level > 0 && $('#object_list li.subject_focus').length && $('#object_list li.subject_focus').hasClass('folder')) {
				Main.enterFolder();
			} else if(this.level > 1 && $('#object_list li li.subject_focus').length) {
				var href = $('#object_list li li.subject_focus .b-file-new__link-material-download').attr('href');
				//alert(href);
				if($.inArray(href.split('.').pop(), supportedExt) != -1){
					this.play_status = 1;
					url = prefixURL + href;
					//alert(url);
					$('#player').addClass('loading');
					Main.handlePlayKey();
				} else {
					Display.statusLine('Неподдерживаемый формат файла');
				}
			}
			$('body').attr('id','level'+this.level);
			break;

		case tvKey.KEY_RETURN:
		case tvKey.KEY_PANEL_RETURN:
			widgetAPI.blockNavigation(event); // блокируем по умолчанию RETURN
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN)
			//если смотрим фильм - в любом раскладе играет или пауза - выходим. экономим на нажатии кнопки СТОП
			{
				Player.stopVideo();
				Main.setWindowMode();
				break;
			} else if(this.level > 1 && $('#object_list li.subject_focus').length){
				Main.exitFolder();
			} else if(this.level == 1){
				$('#secondary').empty();
				$('#poster').empty().css('display','block');
				this.level = 0;
				this.helpbar();
			} else if(Favorites.isVisible) {
				Main.loadLevel0();
			}
			$('body').attr('id','level'+this.level);
			break;

		case tvKey.KEY_LEFT: // лево
			if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN){
				Player.skipBackwardVideoFast();
			}else {
				if (this.level == 0) {
					if(this.search){break;}
					focus = $('#main a.subject_focus');
					if(focus.length) {
						subject_next = focus.prev('a');
						if(subject_next.length){
							subject_next.addClass('subject_focus').siblings().removeClass('subject_focus');
							this.index = subject_next.index();
						} else {
							subject_next = focus;
						}
					} else {
						subject_next = $('#main a.subject-link:eq('+this.index+')').addClass('subject_focus');
					}

					if(Favorites.isVisible){
						var object_list = $('#main');
						if((subject_next.offset().top - object_list.offset().top) < 0){
							var scroll_top = Math.min(object_list.scrollTop(), (object_list.height() - subject_next.height() - 2));
							object_list.animate({scrollTop: (object_list.scrollTop() - scroll_top)}, 400);
						}
						Main.fav_pager();
					}

					this.current_object = subject_next.clone().removeClass('subject_focus').wrap('<div></div>').parent().html();
					this.current_object_url = prefixURL + subject_next.attr('href');
					content_type = subject_next.attr('href').split('/')[1];
					if(content_type == 'audio'){
						$('body').addClass('audio').removeClass('video');
					} else {
						$('body').addClass('video').removeClass('audio');
					}
				} else {
					focus = $('#object_list li.subject_focus');
					if (this.level > 1 && focus.length) {
						Main.exitFolder();
					}
					$('body').attr('id','level'+this.level);
				}
			}
			break;
		case tvKey.KEY_RIGHT: // право
			if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
				Player.skipForwardVideoFast();
			}else {
				if (this.level == 0) {
					if(this.search){break;}
					focus = $('#main a.subject_focus');
					if(focus.length) {
						subject_next = focus.next('a');
						if(subject_next.length){
							subject_next.addClass('subject_focus').siblings().removeClass('subject_focus');
							this.index = subject_next.index();
						} else {
							subject_next = focus;
						}
					} else {
						subject_next = $('#main a.subject-link:eq('+this.index+')').addClass('subject_focus');
					}

					if(Favorites.isVisible){
						var object_list = $('#main');
						if((subject_next.offset().top + subject_next.height()) > (object_list.offset().top + object_list.height())){
							object_list.animate({scrollTop: (object_list.scrollTop() + subject_next.offset().top - object_list.offset().top - 2)}, 400);
						}
						Main.fav_pager();
					}

					this.current_object = subject_next.clone().removeClass('subject_focus').wrap('<div></div>').parent().html();
					this.current_object_url = prefixURL + subject_next.attr('href');
					content_type = subject_next.attr('href').split('/')[1];
					if(content_type == 'audio'){
						$('body').addClass('audio').removeClass('video');
					} else {
						$('body').addClass('video').removeClass('audio');
					}
				} else {
					focus = $('#object_list li.subject_focus');
					if(focus.length && focus.hasClass('folder')) {
						Main.enterFolder();
					}
					$('body').attr('id','level'+this.level);
				}
			}
			break;
		case tvKey.KEY_UP:
			if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
				break;
			} else {
				if (this.level == 0) {
					focus = $('#main .subject_focus');
					if(this.search){
						if(focus.length && this.index > 0) {
							focus.removeClass('subject_focus');
							this.index -= 1;
						} else {
							this.doKeyEvent(tvKey.KEY_CH_DOWN);
							break;
						}
						subject_next = $('#main tr:eq('+this.index+')').addClass('subject_focus');

						var make_object_for_save = $('.image-wrap a', subject_next).clone().addClass('subject-link');
						make_object_for_save.append('<span>'+$('.image-wrap a', subject_next).attr('title')+'</span>');
						this.current_object = make_object_for_save[0].outerHTML;
						Main.current_object_url = prefixURL + make_object_for_save.attr('href');
						content_type = make_object_for_save.attr('href').split('/')[1];
					} else {
						if(focus.length) {
							if(this.index < 5) {
								break;
							}
							subject_next = $('#main a.subject-link').eq(this.index - 5);
							if(subject_next.length){
								subject_next.addClass('subject_focus').siblings().removeClass('subject_focus');
								this.index = subject_next.index();
							}
						} else {
							subject_next = $('#main a.subject-link:eq('+this.index+')').addClass('subject_focus');
						}
						var make_object_for_save = subject_next.clone().removeClass('subject_focus');
						$('.b-poster-info', make_object_for_save).remove();
						this.current_object = make_object_for_save.wrap('<div></div>').parent().html();
						this.current_object_url = prefixURL + subject_next.attr('href');
						content_type = subject_next.attr('href').split('/')[1];
					}

					if(this.search || Favorites.isVisible){
						var object_list = $('#main');
						if((subject_next.offset().top - object_list.offset().top) < 0){
							var scroll_top = Math.min(object_list.scrollTop(), (object_list.height() - subject_next.height() - 2));
							object_list.animate({scrollTop: (object_list.scrollTop() - scroll_top)}, 400);
						}
					}
					if(Favorites.isVisible){
						Main.fav_pager();
					}

					if(content_type == 'audio'){
						$('body').addClass('audio').removeClass('video');
					} else {
						$('body').addClass('video').removeClass('audio');
					}
				} else {
					var object_list = $('#object_list');
					focus = $('li.subject_focus', object_list);
					if(focus.length){
						subject_next = focus.prev('li');
						if(subject_next.length){
							subject_next.addClass('subject_focus').siblings().removeClass('subject_focus');
							if((subject_next.offset().top - object_list.offset().top) < 0){
								var scroll_top = Math.min(object_list.scrollTop(), (object_list.height() - subject_next.height()));
								object_list.animate({scrollTop: (object_list.scrollTop() - scroll_top)}, 400);
							}
						} else if(this.level == 1) {
							$('#object_description').css('visibility','visible').slideDown();
							$('#poster').hide();
							focus.removeClass('subject_focus');
						}
					}
				}
			}
			break;
		case tvKey.KEY_DOWN:
			if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
				break;
			} else {
				if (this.level == 0) {
					focus = $('#main .subject_focus');
					if(this.search){
						if(focus.length) {
							focus.removeClass('subject_focus');
							this.index += 1;
						}
						subject_next = $('#main tr:eq('+this.index+')');
						if(!subject_next.length){
							this.doKeyEvent(tvKey.KEY_CH_UP);
							break;
						}
						subject_next.addClass('subject_focus');

						var make_object_for_save = $('.image-wrap a', subject_next).clone().addClass('subject-link');
						make_object_for_save.append('<span>'+$('.image-wrap a', subject_next).attr('title')+'</span>');
						this.current_object = make_object_for_save[0].outerHTML;
						Main.current_object_url = prefixURL + make_object_for_save.attr('href');
						content_type = make_object_for_save.attr('href').split('/')[1];
					} else {
						if(focus.length) {
							var index_next = this.index + 5;
							if((index_next + 1) > $('#main a.subject-link').length){
								//index_next = this.index + 5 - $('#main a.subject-link').length;
								break;
							}
							subject_next = $('#main a.subject-link').eq(index_next);
							if(subject_next.length){
								subject_next.addClass('subject_focus').siblings().removeClass('subject_focus');
								this.index = subject_next.index();
							}
						} else {
							subject_next = $('#main a.subject-link:eq('+this.index+')').addClass('subject_focus');
						}
						var make_object_for_save = subject_next.clone().removeClass('subject_focus');
						$('.b-poster-info', make_object_for_save).remove();
						this.current_object = make_object_for_save.wrap('<div></div>').parent().html();
						this.current_object_url = prefixURL + subject_next.attr('href');
						content_type = subject_next.attr('href').split('/')[1];
					}

					if(this.search || Favorites.isVisible){
						var object_list = $('#main');
						if((subject_next.offset().top + subject_next.height()) > (object_list.offset().top + object_list.height())){
							object_list.animate({scrollTop: (object_list.scrollTop() + subject_next.offset().top - object_list.offset().top - 2)}, 400);
						}
					}
					if(Favorites.isVisible){
						Main.fav_pager();
					}

					if(content_type == 'audio'){
						$('body').addClass('audio').removeClass('video');
					} else {
						$('body').addClass('video').removeClass('audio');
					}
				} else {
					var object_list = $('#object_list');
					focus = $('li.subject_focus', object_list);
					if(!focus.length){
						$('#object_description').slideUp().css('visibility','hidden');
						$('#poster').show();
						$('li:eq(0)', object_list).addClass('subject_focus');
					} else {
						subject_next = focus.next('li');
						if(subject_next.length){
							subject_next.addClass('subject_focus').prev('li').removeClass('subject_focus');
							if((subject_next.offset().top + subject_next.height()) > (object_list.offset().top + object_list.height())){
								object_list.animate({scrollTop: (object_list.scrollTop() + subject_next.offset().top - object_list.offset().top)}, 400);
							}
						}
					}
				}
			}
			break;
		case tvKey.KEY_RED:
		case tvKey.KEY_CHLIST:
			//if (this.level == 0)
				Favorites.open();
			break;
		case tvKey.KEY_YELLOW:
			if (Favorites.isVisible){
				Favorites.del();
			}else{
				Favorites.add();
			}
			break;
		case tvKey.KEY_ASPECT:
			if (this.mode == this.WINDOW || content_type == 'audio') { // не переключаем в свернутом режиме
				break;
			}
		case tvKey.KEY_BLUE: // переключение типа полноэкранного режима (циклично от
			if (this.level == 0 && !this.search && !Favorites.isVisible){
				Main.query_page = 1;
				Main.sortSelectNext();
			}else if(this.mode == this.FULLSCREEN && content_type == 'video'){
				currentFSMode = (currentFSMode < maxFSMode) ? currentFSMode + 1 : 1;
				Player.setScreenMode(currentFSMode);
			}
			break;
		case tvKey.KEY_GREEN: // TODO Показать жанры
			if (this.level == 0 && !this.search && !Favorites.isVisible){}
			break;

		case tvKey.KEY_1:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.PercentJump(1);
			} else if (this.level == 0){
				content_type = 'video';
				content_subtype = 'films';
				load_url = prefixURL + "/video/films/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;
		case tvKey.KEY_2:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.PercentJump(2);
			} else if (this.level == 0){
				content_type = 'video';
				content_subtype = 'cartoons';
				load_url = prefixURL + "/video/cartoons/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;
		case tvKey.KEY_3:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.PercentJump(3);
			} else if (this.level == 0){
				content_type = 'video';
				content_subtype = 'clips';
				load_url = prefixURL + "/video/clips/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;
		case tvKey.KEY_4:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.PercentJump(4);
			} else if (this.level == 0){
				content_type = 'video';
				content_subtype = 'serials';
				load_url = prefixURL + "/video/serials/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;
		case tvKey.KEY_5:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.PercentJump(5);
			} else if (this.level == 0){
				content_type = 'video';
				content_subtype = 'cartoonserials';
				load_url = prefixURL + "/video/cartoonserials/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;
		case tvKey.KEY_6:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.PercentJump(6);
			} else if (this.level == 0){
				content_type = 'video';
				content_subtype = 'tvshow';
				load_url = prefixURL + "/video/tvshow/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;
		case tvKey.KEY_7:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.PercentJump(7);
			} else if (this.level == 0){
				content_type = 'video';
				content_subtype = 'concerts';
				load_url = prefixURL + "/video/concerts/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;
		case tvKey.KEY_8:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.PercentJump(8);
			} else if (this.level == 0){
				content_type = 'audio';
				content_subtype = 'collections';
				load_url = prefixURL + "/audio/collections/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;
		case tvKey.KEY_9:
			if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
				Player.PercentJump(9);
			} else if (this.level == 0){
				content_type = 'audio';
				content_subtype = 'albums';
				load_url = prefixURL + "/audio/albums/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;
		case tvKey.KEY_0:
			if (this.level == 0){
				content_type = 'audio';
				content_subtype = 'soundtracks';
				load_url = prefixURL + "/audio/soundtracks/?sort=" + sort_by;
				Main.query_page = 1;
				Main.loadLevel0();
			}
			break;

		/*
		case tvKey.KEY_VOL_UP:
		case tvKey.KEY_PANEL_VOL_UP:
			alert("VOL_UP");
			if (this.mute == 0) {
				Audio.setRelativeVolume(0);
			}
			break;
		case tvKey.KEY_VOL_DOWN:
		case tvKey.KEY_PANEL_VOL_DOWN:
			alert("VOL_DOWN");
			if (this.mute == 0) {
				Audio.setRelativeVolume(1);
			}
			break;
		case tvKey.KEY_MUTE:
			alert("MUTE");
			this.muteMode();
			break;
		*/

		default:
			//alert("Unhandled key");
			break;
	}
};

Main.pager = function(){
	var previous_link = (1 == Main.query_page)? ' ' : '<a class="previous-link" data-page="' + (Main.query_page - 1) + '" href="' + load_url + '&page=' + (Main.query_page - 1) + '">&lt;-</a>';
	var next_link = '<a class="next-link" data-page="' + (Main.query_page + 1) + '" href="' + load_url + '&page=' + (Main.query_page + 1) + '">-&gt;</a>';
	$('#pager .prefix').text('Страница:')
			.next().html(previous_link)
			.next().text(Main.query_page)
			.next().html(next_link);
};

Main.fav_pager = function(){
	$('#pager .prefix').text('Индекс:')
			.next().empty()
			.next().text((Main.index + 1) + ' / ' + Favorites.fav_qty)
			.next().empty();
};
Main.helpbar = function(){
	if(this.level == 0){
		if(this.search){
			$('#keyhelp').empty().sfKeyHelp({
				'updown':'Навиг. <b class="icon">CH<sup>+/-</sup></b> Cтр.',
				'red':'<b class="icon">CHLIST</b> Избр.',
				'enter':'Выбор',
				'tools':'Поиск',
				'yellow':'Доб. в Избр.',
				'return':'Выход'
			});
		} else if(Favorites.isVisible){
			$('#keyhelp').empty().sfKeyHelp({
				'move':'Навиг.',
				'enter':'Выбор',
				'tools':'Поиск',
				'yellow':'Удалить. из Избр.',
				'return':'Категория Фильмы'
			});
		} else {
			$('#keyhelp').empty().sfKeyHelp({
				'number':'Катег.',
				'move':'Навиг. <b class="icon">CH<sup>+/-</sup></b> Cтр.',
				'red':'<b class="icon">CHLIST</b> Избр.',
				'enter':'Выбор',
				'tools':'Поиск',
				'blue':'Сорт.',
				'yellow':'Доб. в Избр.',
				'return':'Выход'
			});
		}
	} else {
		$('#keyhelp').empty().sfKeyHelp({
			'updown':'Навиг. <b class="icon">CH<sup>+/-</sup></b> Прокрутка',
			'leftright':'Войти/Выйти из папки',
			'enter':'Выбор',
			'yellow':'Доб. в Избр.',
			'tools':'Поиск',
			'return':'Назад'
		});
	}
};

Main.enterFolder = function() {
	var focus = $('#object_list li.subject_focus');
	if(focus.hasClass('loaded') || $('ul.filelist', focus).length || $('ul.ftplist', focus).length){
		focus.removeClass('subject_focus').addClass('open');
		focus.find('li:eq(0)').addClass('subject_focus');
	} else {
		var load_url = this.current_object_url + '?ajax&folder=' + $('a.title', focus).attr('name').replace('fl','');
		$.ajax({
			type    : "GET",
			url     : load_url,
			cache   : false,
			timeout : 10000,
			success : function (msg) {
				msg = msg.replace(/\s+/g, ' ');
				var content = $('<div>'+msg+'</div>');
				$('.b-transparent-area, a.link-more, .b-subtypes-list',content).remove();
				focus.addClass('loaded open').removeClass('subject_focus').append(content.html());
				focus.find('li:eq(0)').addClass('subject_focus');
			},
			error   : function (msg) {
				msg = msg.replace(/\s+/g, ' ');
				focus.append('<div class="error">'+msg+'</div>');
			},
			complete: function () {
				$('body').removeClass('loading');
			}
		});
	}
	this.level += 1;
};
Main.exitFolder = function() {
	var focus = $('#object_list li li.subject_focus');
	if(focus.length){
		focus.removeClass('subject_focus');
		focus.parent('ul').parent('li').addClass('subject_focus').removeClass('open');
		this.level -= 1;
	}
};

Main.handlePauseKey = function() {
	switch (Player.getState()) {
		case Player.PLAYING:
			Player.pauseVideo();
			this.play_status = 0; // пауза
			break;
		case Player.PAUSED:
			Player.resumeVideo();
			break;
		default:
			//alert("Ignoring pause key, not in correct state");
			break;
	}
};

Main.handlePlayKey = function() {
	if (this.play_status == 1) {
		Player.stopVideo();
		Player.playVideo(url);
	}
	switch (Player.getState()) {
		case Player.STOPPED:
			Player.playVideo(url);
			break;
		case Player.PAUSED:
			Player.resumeVideo();
			break;
		default:
			//alert("Ignoring play key, not in correct state");
			break;
	}

	$("#play_name").text($('#object_list li.subject_focus .b-file-new__link-material-filename-text').text());

};

Main.setFullScreenMode = function() {
	if (this.mode != this.FULLSCREEN) {
		if(content_type == 'video')
			$("body").addClass('fullscreen');
		this.mode = this.FULLSCREEN;
	}
};

Main.setWindowMode = function() {
	if (this.mode != this.WINDOW) {
		Display.hideplayer();
		Player.setWindow();
		$("body").removeClass('fullscreen');
		this.mode = this.WINDOW;
		this.play_status = 1;// играть c начала
	}
};

Main.toggleMode = function() {
	switch (this.mode) {
		case this.WINDOW:
			this.setFullScreenMode();
			break;

		case this.FULLSCREEN:
			this.setWindowMode();
			break;

		default:
			break;
	}
};

Main.sortSelectNext = function() {
	var sort = $('#sort a.selected'),
			index = sort.parent().index() + 1;
	if (index > 2){
		index = 0;
	}
	clearTimeout(time_out);
	sort.removeClass('selected');
	$('#sort li:eq('+index+') a').addClass('selected');
	if(index != this.sort_index){
		time_out = setTimeout(function(){
			load_url = prefixURL + $('#sort li').eq(index).find('a').attr('href');
			Main.loadLevel0();
		},500);
	}
};

Main.selectNextVideo = function() {
	var object_list = $('#object_list'),
			subject_next = $('li.subject_focus', object_list).next('li');
	if(subject_next.length){
		subject_next.addClass('subject_focus').prev('li').removeClass('subject_focus');
		if((subject_next.offset().top + subject_next.height()) > object_list.height()){
			object_list.scrollTop(subject_next.offset().top);
		}
		url = prefixURL + $('li li.subject_focus .b-file-new__link-material-download', object_list).attr('href');
	} else {
		url = '';
	}
};

Main.htmlList = function(level, json){
	var content = '';
	jQuery.each(level, function(n,item){
		if(!item.meta1) item.meta1 = '';
		if(item.type == 'folder'){
			content += '<li class="folder"><div class="b-folder-mark"></div><div class="title"><b>' + item.name + '</b></div><span class="material-details">' + item.meta1 + '</span><span class="material-size">' + item.meta2 + '</span>';
			var level_n = Main.getList(json, item.id);
			if(level_n.length){
				content += '<ul class="ftplist">';
				content += Main.htmlList(level_n, json);
				content += '</ul>';
			}
			content += '</li>';
		} else{
			content += '<li class="file" style="background-image:url(' + item.icon + ');"><div class="title"><a class="b-file-new__link-material-download" href="' + item.link + '">' + item.name + '</a></div><span class="material-details">' + item.filename + '</span><span class="material-size">' + item.meta1 + '</span></li>';
		}
	});
	return content;
}
Main.getList = function(list, fid){
	var new_list = list.filter(function(row){
		return (row.fid == fid);
	});
	return new_list;
}

Main.getCookies = function(cname){
	var name = cname + "=";
	var ca = document.cookie.split(';');
	for(var i = 0; i < ca.length; i++){
		var c = ca[i].trim();
		if(c.indexOf(name) == 0) return c.substring(name.length, c.length);
	}
	return "";
}

/*
Main.setMuteMode = function() {
	if (this.mute != this.YMUTE) {
		var volumeElement = document.getElementById("volumeInfo");
		Audio.plugin.SetUserMute(true);
		document.getElementById("volumeBar").style
				.backgroundImage = "url(Images/videoBox/muteBar.png)";
		document.getElementById("volumeIcon").style
				.backgroundImage = "url(Images/videoBox/mute.png)";
		widgetAPI.putInnerHTML(volumeElement, "MUTE");
		this.mute = this.YMUTE;
	}
};

Main.noMuteMode = function() {
	if (this.mute != this.NMUTE) {
		Audio.plugin.SetUserMute(false);
		document.getElementById("volumeBar").style
				.backgroundImage = "url(Images/videoBox/volumeBar.png)";
		document.getElementById("volumeIcon").style
				.backgroundImage = "url(Images/videoBox/volume.png)";
		Display.setVolume( Audio.getVolume() );
		this.mute = this.NMUTE;
	}
};

Main.muteMode = function() {
	switch (this.mute) {
		case this.NMUTE:
			this.setMuteMode();
			break;
		case this.YMUTE:
			this.noMuteMode();
			break;
		default:
			//alert("ERROR: unexpected mode in muteMode");
			break;
	}
};
*/

